package dev.shadowsoffire.apotheosis;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.mojang.brigadier.builder.LiteralArgumentBuilder;
import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.advancements.AdvancementTriggers;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import dev.shadowsoffire.apotheosis.adventure.affix.augmenting.RerollResultMessage;
import dev.shadowsoffire.apotheosis.adventure.client.BossSpawnMessage;
import dev.shadowsoffire.apotheosis.adventure.net.RadialStateChangeMessage;
import dev.shadowsoffire.apotheosis.compat.PatchouliCompat;
import dev.shadowsoffire.apotheosis.ench.EnchModule;
import dev.shadowsoffire.apotheosis.ench.table.ClueMessage;
import dev.shadowsoffire.apotheosis.ench.table.StatsMessage;
import dev.shadowsoffire.apotheosis.garden.GardenModule;
import dev.shadowsoffire.apotheosis.potion.PotionModule;
import dev.shadowsoffire.apotheosis.spawn.SpawnerModule;
import dev.shadowsoffire.apotheosis.util.ModuleCondition;
import dev.shadowsoffire.apotheosis.util.ParticleMessage;
import dev.shadowsoffire.apotheosis.village.VillageModule;
import dev.shadowsoffire.placebo.config.Configuration;
import dev.shadowsoffire.placebo.network.MessageHelper;
import dev.shadowsoffire.placebo.network.MessageProvider;
import dev.shadowsoffire.placebo.recipe.NBTIngredient;
import dev.shadowsoffire.placebo.recipe.RecipeHelper;
import dev.shadowsoffire.placebo.util.RunnableReloader;
import java.io.File;
import net.minecraft.ChatFormatting;
import net.minecraft.commands.CommandSourceStack;
import net.minecraft.commands.Commands;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.server.packs.resources.PreparableReloadListener;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.alchemy.Potion;
import net.minecraft.world.item.alchemy.PotionUtils;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.level.ItemLike;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.common.crafting.CraftingHelper;
import net.minecraftforge.common.crafting.conditions.IConditionSerializer;
import net.minecraftforge.event.AddReloadListenerEvent;
import net.minecraftforge.event.RegisterCommandsEvent;
import net.minecraftforge.event.entity.player.AttackEntityEvent;
import net.minecraftforge.eventbus.api.Event;
import net.minecraftforge.eventbus.api.EventPriority;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.ModList;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import net.minecraftforge.fml.loading.FMLPaths;
import net.minecraftforge.network.NetworkRegistry;
import net.minecraftforge.network.simple.SimpleChannel;

@Mod("apotheosis")
public class Apotheosis {
  public static final String MODID = "apotheosis";
  
  public static final SimpleChannel CHANNEL = NetworkRegistry.ChannelBuilder.named(new ResourceLocation("apotheosis", "apotheosis"))
    .clientAcceptedVersions(s -> true)
    .serverAcceptedVersions(s -> true)
    .networkProtocolVersion(() -> "1.0.0")
    .simpleChannel();
  
  public static final RecipeHelper HELPER = new RecipeHelper("apotheosis");
  
  public static File configDir;
  
  public static Configuration config;
  
  public static boolean enableEnch = true;
  
  public static boolean enableAdventure = true;
  
  public static boolean enableSpawner = true;
  
  public static boolean enablePotion = true;
  
  public static boolean enableVillage = true;
  
  public static boolean enableGarden = true;
  
  public static boolean giveBook = true;
  
  private static float localAtkStrength = 1.0F;
  
  static {
    configDir = new File(FMLPaths.CONFIGDIR.get().toFile(), "apotheosis");
    config = new Configuration(new File(configDir, "apotheosis.cfg"));
    enableEnch = config.getBoolean("Enable Enchantment Module", "general", true, "If the enchantment module is enabled.");
    enableAdventure = config.getBoolean("Enable Adventure Module", "general", true, "If the adventure module is loaded.");
    enableSpawner = config.getBoolean("Enable Spawner Module", "general", true, "If the spawner module is enabled.");
    enablePotion = config.getBoolean("Enable Potion Module", "general", true, "If the potion module is loaded.");
    enableVillage = config.getBoolean("Enable Village Module", "general", true, "If the village module is loaded.");
    enableGarden = config.getBoolean("Enable Garden Module", "general", true, "If the garden module is loaded.");
    giveBook = config.getBoolean("Give Book on First Join", "general", true, "If the Chronicle of Shadows is given to new players.");
    config.setTitle("Apotheosis Module Control");
    config.setComment("This file allows individual modules of Apotheosis to be enabled or disabled.\nChanges will have no effect until the next game restart.\nThis file must match on client and server.");
    if (config.hasChanged())
      config.save(); 
  }
  
  public Apotheosis() {
    IEventBus bus = FMLJavaModLoadingContext.get().getModEventBus();
    if (enableEnch)
      bus.register(new EnchModule()); 
    if (enableSpawner)
      bus.register(new SpawnerModule()); 
    if (enableGarden)
      bus.register(new GardenModule()); 
    if (enableAdventure)
      bus.register(new AdventureModule()); 
    if (enablePotion)
      bus.register(new PotionModule()); 
    if (enableVillage)
      bus.register(new VillageModule()); 
    if (config.hasChanged())
      config.save(); 
    bus.post((Event)new ApotheosisConstruction());
    bus.addListener(this::init);
    MinecraftForge.EVENT_BUS.addListener(this::reloads);
    MinecraftForge.EVENT_BUS.addListener(this::trackCooldown);
    MinecraftForge.EVENT_BUS.addListener(this::cmds);
    if (ModList.get().isLoaded("patchouli"))
      PatchouliCompat.register(); 
    Apoth.RecipeTypes.FLETCHING.getClass();
  }
  
  @SubscribeEvent
  public void init(FMLCommonSetupEvent e) {
    MessageHelper.registerMessage(CHANNEL, 0, (MessageProvider)new ParticleMessage.Provider());
    MessageHelper.registerMessage(CHANNEL, 1, (MessageProvider)new BossSpawnMessage.Provider());
    MessageHelper.registerMessage(CHANNEL, 2, (MessageProvider)new ClueMessage.Provider());
    MessageHelper.registerMessage(CHANNEL, 3, (MessageProvider)new StatsMessage.Provider());
    MessageHelper.registerMessage(CHANNEL, 4, (MessageProvider)new RadialStateChangeMessage.Provider());
    MessageHelper.registerMessage(CHANNEL, 5, (MessageProvider)new RerollResultMessage.Provider());
    e.enqueueWork(() -> {
          AdvancementTriggers.init();
          CraftingHelper.register((IConditionSerializer)new ModuleCondition.Serializer());
        });
  }
  
  @SubscribeEvent(priority = EventPriority.LOW)
  public void reloads(AddReloadListenerEvent e) {
    e.addListener((PreparableReloadListener)RunnableReloader.of(() -> MinecraftForge.EVENT_BUS.post((Event)new ApotheosisReloadEvent())));
  }
  
  @SubscribeEvent
  public void trackCooldown(AttackEntityEvent e) {
    Player p = e.getEntity();
    localAtkStrength = p.m_36403_(0.5F);
  }
  
  @SubscribeEvent
  public void cmds(RegisterCommandsEvent e) {
    LiteralArgumentBuilder<CommandSourceStack> builder = Commands.m_82127_("apoth");
    MinecraftForge.EVENT_BUS.post((Event)new ApotheosisCommandEvent(builder));
    e.getDispatcher().register(builder);
  }
  
  public static Ingredient potionIngredient(Potion type) {
    return (Ingredient)new NBTIngredient(PotionUtils.m_43549_(new ItemStack((ItemLike)Items.f_42589_), type));
  }
  
  public static ResourceLocation loc(String s) {
    return new ResourceLocation("apotheosis", s);
  }
  
  public static float getLocalAtkStrength(Entity entity) {
    if (entity instanceof Player)
      return localAtkStrength; 
    return 1.0F;
  }
  
  public static MutableComponent sysMessageHeader() {
    return Component.m_237110_("[%s] ", new Object[] { Component.m_237113_("Apoth").m_130940_(ChatFormatting.GOLD) });
  }
}
